diff --git a/testing/test_image_utils.py b/testing/test_image_utils.py
index f785dec..874dadc 100644
--- a/testing/test_image_utils.py
+++ b/testing/test_image_utils.py
@@ -5,70 +5,93 @@
 
 '''Unit tests for libtaskotron/image_utils.py'''
 
+import pytest
+
 from libtaskotron.image_utils import devise_environment
-from libtaskotron.executor import Playbook_Data
 from libtaskotron import config
 
 class TestDeviseEnvironment:
 
     def setup_method(self, method):
         self.arg_data = {
-            'item': 'htop-2.0.2-4.fc27',
+            'item': 'htop-2.0.2-4.fc20',
             'type': 'koji_build',
-            'arch': 'noarch',
+            'arch': 'i686',
+        }
+        self.playbook_vars = {
+            'taskotron_match_host_distro': True,
+            'taskotron_match_host_release': True,
+            'taskotron_match_host_arch': True,
         }
-        self.playbook_data = Playbook_Data({
-            'vars': {
-                'taskotron_match_host_distro': True,
-                'taskotron_match_host_release': True,
-                'taskotron_match_host_arch': False
-            }
-        })
+        self.cfg = config.get_config()
 
     def test_koji_build(self):
-        env = devise_environment(self.arg_data, self.playbook_data)
+        env = devise_environment(self.arg_data, self.playbook_vars)
         assert env['distro'] == 'fedora'
-        assert env['release'] == '27'
-        assert env['arch'] == config.get_config().default_disposable_arch
+        assert env['release'] == '20'
+        assert env['arch'] == self.arg_data['arch']
 
     def test_koji_tag(self):
         self.arg_data = {
-            'item': 'f27-updates-pending',
+            'item': 'f20-updates-pending',
             'type': 'koji_tag',
-            'arch': 'x86_64',
+            'arch': 'i686',
         }
-        self.playbook_data.match_host_arch = True
-        env = devise_environment(self.arg_data, self.playbook_data)
+        env = devise_environment(self.arg_data, self.playbook_vars)
         assert env['distro'] == 'fedora'
-        assert env['release'] == '27'
+        assert env['release'] == '20'
         assert env['arch'] == self.arg_data['arch']
 
     def test_unknown_distro(self):
         self.arg_data['item'] = 'htop-2.0.2-4.el7'
-        env = devise_environment(self.arg_data, self.playbook_data)
-        assert env['distro'] == config.get_config().default_disposable_distro
-        assert env['release'] == config.get_config().default_disposable_release
+        env = devise_environment(self.arg_data, self.playbook_vars)
+        assert env['distro'] == self.cfg.default_disposable_distro
+        assert env['release'] == self.cfg.default_disposable_release
+        assert env['arch'] == self.arg_data['arch']
 
     def test_match_host_arch_true(self):
-        self.arg_data = {
-            'item': 'htop-2.0.2-4.fc27',
-            'type': 'koji_build',
-            'arch': 'armhfp',
-        }
-        self.playbook_data.match_host_arch = True
-        env = devise_environment(self.arg_data, self.playbook_data)
+        env = devise_environment(self.arg_data, self.playbook_vars)
         assert env['distro'] == 'fedora'
-        assert env['release'] == '27'
-        assert env['arch'] == 'armhfp'
+        assert env['release'] == '20'
+        assert env['arch'] == self.arg_data['arch']
 
     def test_match_host_arch_false(self):
-        self.arg_data = {
-            'item': 'htop-2.0.2-4.fc27',
-            'type': 'koji_build',
-            'arch': 'armhfp',
-        }
-        self.playbook_data.match_host_arch = False
-        env = devise_environment(self.arg_data, self.playbook_data)
+        self.playbook_vars['taskotron_match_host_arch'] = False
+        env = devise_environment(self.arg_data, self.playbook_vars)
         assert env['distro'] == 'fedora'
-        assert env['release'] == '27'
-        assert env['arch'] == config.get_config().default_disposable_arch
+        assert env['release'] == '20'
+        assert env['arch'] == self.cfg.default_disposable_arch
+
+    def test_match_host_release_true(self):
+        env = devise_environment(self.arg_data, self.playbook_vars)
+        assert env['distro'] == 'fedora'
+        assert env['release'] == '20'
+        assert env['arch'] == self.arg_data['arch']
+
+    def test_match_host_release_false(self):
+        self.playbook_vars['taskotron_match_host_release'] = False
+        env = devise_environment(self.arg_data, self.playbook_vars)
+        assert env['distro'] == 'fedora'
+        assert env['release'] == self.cfg.default_disposable_release
+        assert env['arch'] == self.arg_data['arch']
+
+    @pytest.mark.parametrize('match_arch', [True, False])
+    def test_noarch_to_default(self, match_arch):
+        self.arg_data['arch'] = 'noarch'
+        self.playbook_vars['taskotron_match_host_arch'] = match_arch
+        env = devise_environment(self.arg_data, self.playbook_vars)
+        assert env['distro'] == 'fedora'
+        assert env['release'] == '20'
+        assert env['arch'] == self.cfg.default_disposable_arch
+
+    def test_no_disttag(self):
+        self.arg_data['item'] = 'htop-2.0.2-4'
+        env = devise_environment(self.arg_data, self.playbook_vars)
+        assert env['distro'] == 'fedora'
+        assert env['release'] == self.cfg.default_disposable_release
+        assert env['arch'] == self.arg_data['arch']
+
+    def test_flavor(self):
+        '''Flavor is always the default one'''
+        env = devise_environment(self.arg_data, self.playbook_vars)
+        assert env['flavor'] == self.cfg.default_disposable_flavor
diff --git a/testing/test_vm.py b/testing/test_vm.py
index bd01b24..f0e35b6 100644
--- a/testing/test_vm.py
+++ b/testing/test_vm.py
@@ -28,7 +28,8 @@ class TestvmImagePrepare(object):
         test_vm = vm.TestCloudMachine(self.ref_uuid)
 
         with pytest.raises(exc.TaskotronImageError):
-            test_vm._prepare_image()
+            test_vm._prepare_image(distro=None, release=None, flavor=None,
+                arch=None)
 
     def should_behave_on_success(self, monkeypatch):
         stub_image = MagicMock()
@@ -38,7 +39,8 @@ class TestvmImagePrepare(object):
 
         test_vm = vm.TestCloudMachine(self.ref_uuid)
 
-        test_vm._prepare_image()
+        test_vm._prepare_image(distro=None, release=None, flavor=None,
+            arch=None)
 
 
 class TestvmInstancePrepare(object):

